Accessible Objects
3
AT-SPI-CSPI Library

# Accessible Objects

The base accessibility interface which all accessible objects implement.

## Synopsis

    struct              Accessible;
    void                Accessible_ref                      (Accessible *obj);
    void                Accessible_unref                    (Accessible *obj);
    char*               Accessible_getName                  (Accessible *obj);
    char*               Accessible_getDescription           (Accessible *obj);
    Accessible*         Accessible_getParent                (Accessible *obj);
    long                Accessible_getChildCount            (Accessible *obj);
    Accessible*         Accessible_getChildAtIndex          (Accessible *obj,
                                                             long int childIndex);
    long                Accessible_getIndexInParent         (Accessible *obj);
    AccessibleRelation** Accessible_getRelationSet          (Accessible *obj);
    AccessibleRole      Accessible_getRole                  (Accessible *obj);
    char*               Accessible_getRoleName              (Accessible *obj);
    AccessibleStateSet* Accessible_getStateSet              (Accessible *obj);
    AccessibleAttributeSet* Accessible_getAttributes        (Accessible *obj);
    AccessibleApplication* Accessible_getHostApplication    (Accessible *obj);
    char*               Accessible_getLocalizedRoleName     (Accessible *obj);

    SPIBoolean          Accessible_isAction                 (Accessible *obj);
    SPIBoolean          Accessible_isApplication            (Accessible *obj);
    SPIBoolean          Accessible_isComponent              (Accessible *obj);
    SPIBoolean          Accessible_isDocument               (Accessible *obj);
    SPIBoolean          Accessible_isEditableText           (Accessible *obj);
    SPIBoolean          Accessible_isHypertext              (Accessible *obj);
    SPIBoolean          Accessible_isImage                  (Accessible *obj);
    SPIBoolean          Accessible_isSelection              (Accessible *obj);
    SPIBoolean          Accessible_isStreamableContent      (Accessible *obj);
    SPIBoolean          Accessible_isTable                  (Accessible *obj);
    SPIBoolean          Accessible_isText                   (Accessible *obj);
    SPIBoolean          Accessible_isValue                  (Accessible *obj);
    AccessibleAction*   Accessible_getAction                (Accessible *obj);
    AccessibleApplication* Accessible_getApplication        (Accessible *obj);
    AccessibleComponent* Accessible_getComponent            (Accessible *obj);
    AccessibleDocument* Accessible_getDocument              (Accessible *obj);
    AccessibleEditableText* Accessible_getEditableText      (Accessible *obj);
    AccessibleHypertext* Accessible_getHypertext            (Accessible *obj);
    AccessibleImage*    Accessible_getImage                 (Accessible *obj);
    AccessibleSelection* Accessible_getSelection            (Accessible *obj);
    AccessibleStreamableContent* Accessible_getStreamableContent
                                                            (Accessible *obj);
    AccessibleTable*    Accessible_getTable                 (Accessible *obj);
    AccessibleText*     Accessible_getText                  (Accessible *obj);
    AccessibleValue*    Accessible_getValue                 (Accessible *obj);
    AccessibleUnknown*  Accessible_queryInterface           (Accessible *obj,
                                                             const char *interface_name);

    enum                AccessibleRole;
    char*               AccessibleRole_getName              (AccessibleRole role);

## Description

The Accessible interface provides for a hierarchical tree of accessible objects corresponding to user interface components and content in an accessible application. Accessible objects provide name, descriptive information, state information, and information on the "role" of the object in the user interface. The capabilities of these objects may be queried via interface queries, as they are implemented via interface aggregation. These objects are located in a containment hierarchy with parent/child relationships, and may have other functional relationships to objects within the tree.

## Details

### struct Accessible

    struct Accessible {
    	CORBA_Object objref;
    	/* And some other bits */
    	guint        on_loan : 1;
    	guint        ref_count : 30;
    };

An Accessible object is an opaque object used to refer to an accessible object corresponding to an user interface element.

CORBA_Object objref;

  private data

guint on_loan : 1;

  private data

guint ref_count : 30;

  private data

### Accessible_ref ()

    void                Accessible_ref                      (Accessible *obj);

Increment the reference count for an Accessible object.

`obj` :

  a pointer to the Accessible object on which to operate.

### Accessible_unref ()

    void                Accessible_unref                    (Accessible *obj);

Decrement the reference count for an Accessible object.

`obj` :

  a pointer to the Accessible object on which to operate.

### Accessible_getName ()

    char*               Accessible_getName                  (Accessible *obj);

Get the name of an Accessible object.

`obj` :

  a pointer to the Accessible object on which to operate.

Returns :

  a UTF-8 string indicating the name of the Accessible object. or NULL on exception

### Accessible_getDescription ()

    char*               Accessible_getDescription           (Accessible *obj);

Get the description of an Accessible object.

`obj` :

  a pointer to the Accessible object on which to operate.

Returns :

  a UTF-8 string describing the Accessible object. or NULL on exception

### Accessible_getParent ()

    Accessible*         Accessible_getParent                (Accessible *obj);

Get an Accessible object's parent container.

`obj` :

  a pointer to the Accessible object to query.

Returns :

  a pointer tothe Accessible object which contains the given Accessible instance, or NULL if the `obj` has no parent container.

### Accessible_getChildCount ()

    long                Accessible_getChildCount            (Accessible *obj);

Get the number of children contained by an Accessible object.

`obj` :

  a pointer to the Accessible object on which to operate.

Returns :

  a long indicating the number of Accessible children contained by an Accessible object. or -1 on exception

### Accessible_getChildAtIndex ()

    Accessible*         Accessible_getChildAtIndex          (Accessible *obj,
                                                             long int childIndex);

Get the Accessible child of an Accessible object at a given index.

`obj` :

  a pointer to the Accessible object on which to operate.

`childIndex` :

  a long indicating which child is specified.

Returns :

  a pointer to the Accessible child object at index `childIndex`. or NULL on exception

### Accessible_getIndexInParent ()

    long                Accessible_getIndexInParent         (Accessible *obj);

Get the index of an Accessible object in its containing Accessible.

`obj` :

  a pointer to the Accessible object on which to operate.

Returns :

  a long indicating the index of the Accessible object in its parent (i.e. containing) Accessible instance, or -1 if `obj` has no containing parent or on exception.

### Accessible_getRelationSet ()

    AccessibleRelation** Accessible_getRelationSet          (Accessible *obj);

Get the set of AccessibleRelation objects which describe this Accessible object's relationships with other Accessible objects.

`obj` :

  a pointer to the Accessible object on which to operate.

Returns :

  an array of AccessibleRelation pointers. or NULL on exception

### Accessible_getRole ()

    AccessibleRole      Accessible_getRole                  (Accessible *obj);

Get the UI role of an Accessible object. A UTF-8 string describing this role can be obtained via `Accessible_getRoleName()`.

`obj` :

  a pointer to the Accessible object on which to operate.

Returns :

  the AccessibleRole of the object.

### Accessible_getRoleName ()

    char*               Accessible_getRoleName              (Accessible *obj);

Get a UTF-8 string describing the role this object plays in the UI. This method will return useful values for roles that fall outside the enumeration used in `Accessible_getRole()`.

`obj` :

  a pointer to the Accessible object on which to operate.

Returns :

  a UTF-8 string specifying the role of this Accessible object.

### Accessible_getStateSet ()

    AccessibleStateSet* Accessible_getStateSet              (Accessible *obj);

Gets the current state of an object.

`obj` :

  a pointer to the Accessible object on which to operate.

Returns :

  a pointer to an AccessibleStateSet representing the object's current state.

### Accessible_getAttributes ()

    AccessibleAttributeSet* Accessible_getAttributes        (Accessible *obj);

Get the AttributeSet representing any assigned name-value pair attributes or annotations for this object. For typographic, textual, or textually-semantic attributes, see AccessibleText_getAttributes instead.

`obj` :

  The Accessible being queried.

Returns :

  The name-value-pair attributes assigned to this object.

### Accessible_getHostApplication ()

    AccessibleApplication* Accessible_getHostApplication    (Accessible *obj);

Get the containing AccessibleApplication for an object.

`obj` :

  The Accessible being queried.

Returns :

  the containing AccessibleApplication instance for this object.

### Accessible_getLocalizedRoleName ()

    char*               Accessible_getLocalizedRoleName     (Accessible *obj);

Get a UTF-8 string describing the (localized) role this object plays in the UI. This method will return useful values for roles that fall outside the enumeration used in `Accessible_getRole()`.

`Since`: AT-SPI 1.4

`obj` :

  a pointer to the Accessible object on which to operate.

Returns :

  a UTF-8 string specifying the role of this Accessible object.

### Accessible_isAction ()

    SPIBoolean          Accessible_isAction                 (Accessible *obj);

Query whether the specified Accessible implements AccessibleAction.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  TRUE if `obj` implements the AccessibleAction interface, FALSE otherwise.

### Accessible_isApplication ()

    SPIBoolean          Accessible_isApplication            (Accessible *obj);

Query whether the specified Accessible implements AccessibleApplication.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  TRUE if `obj` implements the AccessibleApplication interface, FALSE otherwise.

### Accessible_isComponent ()

    SPIBoolean          Accessible_isComponent              (Accessible *obj);

Query whether the specified Accessible implements AccessibleComponent.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  TRUE if `obj` implements the AccessibleComponent interface, FALSE otherwise.

### Accessible_isDocument ()

    SPIBoolean          Accessible_isDocument               (Accessible *obj);

Query whether the specified Accessible implements AccessibleDocument.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  TRUE if `obj` implements the AccessibleDocument interface, FALSE otherwise.

### Accessible_isEditableText ()

    SPIBoolean          Accessible_isEditableText           (Accessible *obj);

Query whether the specified Accessible implements AccessibleEditableText.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  TRUE if `obj` implements the AccessibleEditableText interface, FALSE otherwise.

### Accessible_isHypertext ()

    SPIBoolean          Accessible_isHypertext              (Accessible *obj);

Query whether the specified Accessible implements AccessibleHypertext.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  TRUE if `obj` implements the AccessibleHypertext interface, FALSE otherwise.

### Accessible_isImage ()

    SPIBoolean          Accessible_isImage                  (Accessible *obj);

Query whether the specified Accessible implements AccessibleImage.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  TRUE if `obj` implements the AccessibleImage interface, FALSE otherwise.

### Accessible_isSelection ()

    SPIBoolean          Accessible_isSelection              (Accessible *obj);

Query whether the specified Accessible implements AccessibleSelection.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  TRUE if `obj` implements the AccessibleSelection interface, FALSE otherwise.

### Accessible_isStreamableContent ()

    SPIBoolean          Accessible_isStreamableContent      (Accessible *obj);

Query whether the specified Accessible implements AccessibleStreamableContent.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  TRUE if `obj` implements the AccessibleStreamableContent interface, FALSE otherwise.

### Accessible_isTable ()

    SPIBoolean          Accessible_isTable                  (Accessible *obj);

Query whether the specified Accessible implements AccessibleTable.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  TRUE if `obj` implements the AccessibleTable interface, FALSE otherwise.

### Accessible_isText ()

    SPIBoolean          Accessible_isText                   (Accessible *obj);

Query whether the specified Accessible implements AccessibleText.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  TRUE if `obj` implements the AccessibleText interface, FALSE otherwise.

### Accessible_isValue ()

    SPIBoolean          Accessible_isValue                  (Accessible *obj);

Query whether the specified Accessible implements AccessibleValue.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  TRUE if `obj` implements the AccessibleValue interface, FALSE otherwise.

### Accessible_getAction ()

    AccessibleAction*   Accessible_getAction                (Accessible *obj);

Get the AccessibleAction interface for an Accessible.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  a pointer to an AccessibleAction interface instance, or NULL if `obj` does not implement AccessibleAction.

### Accessible_getApplication ()

    AccessibleApplication* Accessible_getApplication        (Accessible *obj);

Get the AccessibleApplication interface for an Accessible.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  a pointer to an AccessibleApplication interface instance, or NULL if `obj` does not implement AccessibleApplication.

### Accessible_getComponent ()

    AccessibleComponent* Accessible_getComponent            (Accessible *obj);

Get the AccessibleComponent interface for an Accessible.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  a pointer to an AccessibleComponent interface instance, or NULL if `obj` does not implement AccessibleComponent.

### Accessible_getDocument ()

    AccessibleDocument* Accessible_getDocument              (Accessible *obj);

Get the AccessibleDocument interface for an Accessible.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  a pointer to an AccessibleDocument interface instance, or NULL if `obj` does not implement AccessibleDocument.

### Accessible_getEditableText ()

    AccessibleEditableText* Accessible_getEditableText      (Accessible *obj);

Get the AccessibleEditableText interface for an Accessible.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  a pointer to an AccessibleEditableText interface instance, or NULL if `obj` does not implement AccessibleEditableText.

### Accessible_getHypertext ()

    AccessibleHypertext* Accessible_getHypertext            (Accessible *obj);

Get the AccessibleHypertext interface for an Accessible.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  a pointer to an AccessibleHypertext interface instance, or NULL if `obj` does not implement AccessibleHypertext.

### Accessible_getImage ()

    AccessibleImage*    Accessible_getImage                 (Accessible *obj);

Get the AccessibleImage interface for an Accessible.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  a pointer to an AccessibleImage interface instance, or NULL if `obj` does not implement AccessibleImage.

### Accessible_getSelection ()

    AccessibleSelection* Accessible_getSelection            (Accessible *obj);

Get the AccessibleSelection interface for an Accessible.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  a pointer to an AccessibleSelection interface instance, or NULL if `obj` does not implement AccessibleSelection.

### Accessible_getStreamableContent ()

    AccessibleStreamableContent* Accessible_getStreamableContent
                                                            (Accessible *obj);

Get the AccessibleStreamableContent interface for an Accessible.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  a pointer to an AccessibleStreamableContent interface instance, or NULL if `obj` does not implement AccessibleStreamableContent.

### Accessible_getTable ()

    AccessibleTable*    Accessible_getTable                 (Accessible *obj);

Get the AccessibleTable interface for an Accessible.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  a pointer to an AccessibleTable interface instance, or NULL if `obj` does not implement AccessibleTable.

### Accessible_getText ()

    AccessibleText*     Accessible_getText                  (Accessible *obj);

Get the AccessibleText interface for an Accessible.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  a pointer to an AccessibleText interface instance, or NULL if `obj` does not implement AccessibleText.

### Accessible_getValue ()

    AccessibleValue*    Accessible_getValue                 (Accessible *obj);

Get the AccessibleValue interface for an Accessible.

`obj` :

  a pointer to the Accessible instance to query.

Returns :

  a pointer to an AccessibleValue interface instance, or NULL if `obj` does not implement AccessibleValue.

### Accessible_queryInterface ()

    AccessibleUnknown*  Accessible_queryInterface           (Accessible *obj,
                                                             const char *interface_name);

Query an Accessible object to for a named interface.

`obj` :

  a pointer to the Accessible instance to query.

`interface_name` :

  a UTF-8 character string specifiying the requested interface.

Returns :

  an instance of the named interface object, if it is implemented by `obj`, or NULL otherwise.

### enum AccessibleRole

    typedef enum
    {
      SPI_ROLE_INVALID,
      SPI_ROLE_ACCEL_LABEL,
      SPI_ROLE_ALERT,
      SPI_ROLE_ANIMATION,
      SPI_ROLE_ARROW,
      SPI_ROLE_CALENDAR,
      SPI_ROLE_CANVAS,
      SPI_ROLE_CHECK_BOX,
      SPI_ROLE_CHECK_MENU_ITEM,
      SPI_ROLE_COLOR_CHOOSER,
      SPI_ROLE_COLUMN_HEADER,
      SPI_ROLE_COMBO_BOX,
      SPI_ROLE_DATE_EDITOR,
      SPI_ROLE_DESKTOP_ICON,
      SPI_ROLE_DESKTOP_FRAME,
      SPI_ROLE_DIAL,
      SPI_ROLE_DIALOG,
      SPI_ROLE_DIRECTORY_PANE,
      SPI_ROLE_DRAWING_AREA,
      SPI_ROLE_FILE_CHOOSER,
      SPI_ROLE_FILLER,
      SPI_ROLE_FONT_CHOOSER,
      SPI_ROLE_FRAME,
      SPI_ROLE_GLASS_PANE,
      SPI_ROLE_HTML_CONTAINER,
      SPI_ROLE_ICON,
      SPI_ROLE_IMAGE,
      SPI_ROLE_INTERNAL_FRAME,
      SPI_ROLE_LABEL,
      SPI_ROLE_LAYERED_PANE,
      SPI_ROLE_LIST,
      SPI_ROLE_LIST_ITEM,
      SPI_ROLE_MENU,
      SPI_ROLE_MENU_BAR,
      SPI_ROLE_MENU_ITEM,
      SPI_ROLE_OPTION_PANE,
      SPI_ROLE_PAGE_TAB,
      SPI_ROLE_PAGE_TAB_LIST,
      SPI_ROLE_PANEL,
      SPI_ROLE_PASSWORD_TEXT,
      SPI_ROLE_POPUP_MENU,
      SPI_ROLE_PROGRESS_BAR,
      SPI_ROLE_PUSH_BUTTON,
      SPI_ROLE_RADIO_BUTTON,
      SPI_ROLE_RADIO_MENU_ITEM,
      SPI_ROLE_ROOT_PANE,
      SPI_ROLE_ROW_HEADER,
      SPI_ROLE_SCROLL_BAR,
      SPI_ROLE_SCROLL_PANE,
      SPI_ROLE_SEPARATOR,
      SPI_ROLE_SLIDER,
      SPI_ROLE_SPIN_BUTTON,
      SPI_ROLE_SPLIT_PANE,
      SPI_ROLE_STATUS_BAR,
      SPI_ROLE_TABLE,
      SPI_ROLE_TABLE_CELL,
      SPI_ROLE_TABLE_COLUMN_HEADER,
      SPI_ROLE_TABLE_ROW_HEADER,
      SPI_ROLE_TEAROFF_MENU_ITEM,
      SPI_ROLE_TERMINAL,
      SPI_ROLE_TEXT,
      SPI_ROLE_TOGGLE_BUTTON,
      SPI_ROLE_TOOL_BAR,
      SPI_ROLE_TOOL_TIP,
      SPI_ROLE_TREE,
      SPI_ROLE_TREE_TABLE,
      SPI_ROLE_UNKNOWN,
      SPI_ROLE_VIEWPORT,
      SPI_ROLE_WINDOW,
      SPI_ROLE_EXTENDED,
      SPI_ROLE_HEADER,
      SPI_ROLE_FOOTER,
      SPI_ROLE_PARAGRAPH,
      SPI_ROLE_RULER,
      SPI_ROLE_APPLICATION,
      SPI_ROLE_AUTOCOMPLETE,
      SPI_ROLE_EDITBAR,
      SPI_ROLE_EMBEDDED,
      SPI_ROLE_ENTRY,
      SPI_ROLE_CHART,
      SPI_ROLE_CAPTION,
      SPI_ROLE_DOCUMENT_FRAME,
      SPI_ROLE_HEADING,
      SPI_ROLE_PAGE,
      SPI_ROLE_SECTION,
      SPI_ROLE_FORM,
      SPI_ROLE_REDUNDANT_OBJECT,
      SPI_ROLE_LINK,
      SPI_ROLE_INPUT_METHOD_WINDOW,
      SPI_ROLE_LAST_DEFINED
    } AccessibleRole;

Describes the role of an object

These are the built-in enumerated roles that UI components can have. Other roles may be added at runtime, so an AccessibleRole >= SPI_ROLE_LAST_DEFINED is not necessarily an error.

`SPI_ROLE_INVALID`

  role is not legal, something is wrong with this object

`SPI_ROLE_ACCEL_LABEL`

  object is a label indicating keyboard accelerators for the parent

`SPI_ROLE_ALERT`

  Object is used to alert the user about something

`SPI_ROLE_ANIMATION`

  Object contains a dynamic or moving image

`SPI_ROLE_ARROW`

  Object is a 2d directional indicator

`SPI_ROLE_CALENDAR`

  Object contains one or more dates, usually arranged into a 2d list

`SPI_ROLE_CANVAS`

  Object that can be drawn into and is used to trap events

`SPI_ROLE_CHECK_BOX`

  Object representd a choice that can be checked or unchecked and provides a separate indicator for the current state.

`SPI_ROLE_CHECK_MENU_ITEM`

  Object is a menu item that behaves like a CHECK_BOX

`SPI_ROLE_COLOR_CHOOSER`

  A specialized dialog that lets the user choose a color.

`SPI_ROLE_COLUMN_HEADER`

  The header for a column of data

`SPI_ROLE_COMBO_BOX`

  A list of choices the user can select from

`SPI_ROLE_DATE_EDITOR`

  Allows entry of a date

`SPI_ROLE_DESKTOP_ICON`

  An inconifed internal frame within a DESKTOP_PANE

`SPI_ROLE_DESKTOP_FRAME`

  A pane that supports internal frames and iconified versions of those internal frames.

`SPI_ROLE_DIAL`

  A rotating/rotatable valuator

`SPI_ROLE_DIALOG`

  A top level window with title bar and a border

`SPI_ROLE_DIRECTORY_PANE`

  A pane that allows the user to navigate through and select the contents of a directory.

`SPI_ROLE_DRAWING_AREA`

  An object used for drawing custom user interface elements

`SPI_ROLE_FILE_CHOOSER`

  A specialized dialog that displays the files in the directory and lets the user select a file, browse a different directory, or specify a filename.

`SPI_ROLE_FILLER`

  A object that fills up space in a user interface

`SPI_ROLE_FONT_CHOOSER`

  Allows selection of a display font

`SPI_ROLE_FRAME`

  A top level window with a title bar, border, menubar, etc.

`SPI_ROLE_GLASS_PANE`

  A pane that is guaranteed to be painted on top of all panes beneath it

`SPI_ROLE_HTML_CONTAINER`

  A document container for HTML, whose children represent the document content.

`SPI_ROLE_ICON`

  A small fixed size picture, typically used to decorate components.

`SPI_ROLE_IMAGE`

  An image, typically static

`SPI_ROLE_INTERNAL_FRAME`

  A frame-like object that is clipped by a desktop pane.

`SPI_ROLE_LABEL`

  An object used to present an icon or short string in an interface

`SPI_ROLE_LAYERED_PANE`

  A specialized pane that allows its children to be drawn in layers providing a form of stacking order.

`SPI_ROLE_LIST`

  An object that presents a list of objects to the user and allows the user to select one or more of them.

`SPI_ROLE_LIST_ITEM`

  An object that represents an element of a list.

`SPI_ROLE_MENU`

  An object usually found inside a menu bar that contains a list of actions the user can choose from.

`SPI_ROLE_MENU_BAR`

  An object usually drawn at the top of the primary dialog box of an application that contains a list of menus the user can choose from.

`SPI_ROLE_MENU_ITEM`

  An object usually contained in a menu that presents an action the user can choose.

`SPI_ROLE_OPTION_PANE`

  A specialized pane whose primary use is inside a DIALOG

`SPI_ROLE_PAGE_TAB`

  An object that is a child of a page tab list

`SPI_ROLE_PAGE_TAB_LIST`

  An object that presents a series of panels (or page tabs), one at a time, through some mechanism provided by the object.

`SPI_ROLE_PANEL`

  A generic container that is often used to group objects.

`SPI_ROLE_PASSWORD_TEXT`

  A text object uses for passwords, or other places where the text content is not shown visibly to the user.

`SPI_ROLE_POPUP_MENU`

  A temporary window that is usually used to offer the user a list of choices, and then hides when the user selects one of those choices.

`SPI_ROLE_PROGRESS_BAR`

  An object used to indicate how much of a task has been completed.

`SPI_ROLE_PUSH_BUTTON`

  A specialized object which the user can interact with to tell the application to do something.

`SPI_ROLE_RADIO_BUTTON`

  A specialized check box that will cause other radio buttons in the same group to become uncghecked when this one is checked.

`SPI_ROLE_RADIO_MENU_ITEM`

  A specialized menu item that behaves like a radio button.

`SPI_ROLE_ROOT_PANE`

  A specialized pane that has a glass pane and a layered pane as its children.

`SPI_ROLE_ROW_HEADER`

  The header for a row of data

`SPI_ROLE_SCROLL_BAR`

  An object usually used to allow a user to incrementally view a large amount of data.

`SPI_ROLE_SCROLL_PANE`

  An object that allows a user to incrementally view a large amount of information.

`SPI_ROLE_SEPARATOR`

  An object usually contained in a menu to provide a visible and logical separation of the contents in a menu.

`SPI_ROLE_SLIDER`

  An object that allows the user to select from a bounded range.

`SPI_ROLE_SPIN_BUTTON`

  An object which allows selection from a set of choices and displays the current choice.

`SPI_ROLE_SPLIT_PANE`

  A specialized panel that presents two other panels at the same time.

`SPI_ROLE_STATUS_BAR`

  An object the display qualitative status information. c.f. PROGRESS_BAR

`SPI_ROLE_TABLE`

  An object used to rpesent information in terms of rows and columns.

`SPI_ROLE_TABLE_CELL`

  An object which is a descendant of a table, with a row/column location. A cell may span multiple rows and columns.

`SPI_ROLE_TABLE_COLUMN_HEADER`

  An object which serves to describe a column in a table.

`SPI_ROLE_TABLE_ROW_HEADER`

  An object which serves to label or describe a row in a table.

`SPI_ROLE_TEAROFF_MENU_ITEM`

  A menu item which allows the menu to be removed from a menubar and placed in its own window

`SPI_ROLE_TERMINAL`

  An object that emulates a teletype or terminal

`SPI_ROLE_TEXT`

  An object that presents text to the user

`SPI_ROLE_TOGGLE_BUTTON`

  A specialized push button that can be checked or unchecked, but does not provide a separate indicator for the current state.

`SPI_ROLE_TOOL_BAR`

  A bar or palette usually composed of push buttons or toggle buttons

`SPI_ROLE_TOOL_TIP`

  An object that provides information about another object

`SPI_ROLE_TREE`

  An object used to represent hierarchical information to the user

`SPI_ROLE_TREE_TABLE`

  An object which represents both hierarchical and tabular information

`SPI_ROLE_UNKNOWN`

  The object contains some SpiAccessible information, but its role is not known.

`SPI_ROLE_VIEWPORT`

  An object usually used in a scroll pane, which restricts the visual area into which its contents are presented.

`SPI_ROLE_WINDOW`

  A top level window with no title or border.

`SPI_ROLE_EXTENDED`

  This object's role is not included in the standard role list and should be queried by name.

`SPI_ROLE_HEADER`

  An object that serves as a document header.

`SPI_ROLE_FOOTER`

  An object that serves as a document footer.

`SPI_ROLE_PARAGRAPH`

  An object which is contains a paragraph of text content.

`SPI_ROLE_RULER`

  An object which describes margins and tab stops, etc. for text objects which it controls (should have CONTROLLER_FOR relation to such).

`SPI_ROLE_APPLICATION`

  An object which corresponds to a desktop application, which may have children of `SPI_ROLE_FRAME` or other type.

`SPI_ROLE_AUTOCOMPLETE`

  The object is a dialog or list containing items for insertion into an entry widget, for instance a list of words for completion of a text entry.

`SPI_ROLE_EDITBAR`

  The object is an editable text object in a toolbar

`SPI_ROLE_EMBEDDED`

  The object is an embedded component container. This role is a "grouping" hint that the contained objects share a context which is different from the container in which this accessible is embedded. Uses: document embedding, "panel applets", etc.

`SPI_ROLE_ENTRY`

  The object is a component whose textual content may be entered or modified by the user, provided `SPI_STATE_EDITABLE` is present.

`SPI_ROLE_CHART`

  The object is a graphical depiction of quantitative data. It may contain multiple subelements whose attributes and/or description may be queried to obtain both the quantitative data and information about how the data is being presented. The LABELLED_BY relation is particularly important in interpreting objects of this type, as is the accessible-description property.

`SPI_ROLE_CAPTION`

  The object contains descriptive information, usually textual, about another user interface element such as a table, chart, or image.

`SPI_ROLE_DOCUMENT_FRAME`

  The object is a visual frame or container which contains a view of document content. Document frames may occur within another Document instance, in which case the second document may be said to be embedded in the containing instance. HTML frames are often ROLE_DOCUMENT_FRAME. Either this object, or a singleton descendant, should implement the Document interface.

`SPI_ROLE_HEADING`

  The object serves as a heading for content which follows it in a document. The 'heading level' of the heading, if availabe, may be obtained by querying the object's attributes.

`SPI_ROLE_PAGE`

  The object is a containing instance which encapsulates a page of information. `SPI_ROLE_PAGE` is used in documents and content which support a paginated navigation model.

`SPI_ROLE_SECTION`

  The object is a containing instance of document content which constitutes a particular 'logical' section of the document. The type of content within a section, and the nature of the section division itself, may be obtained by querying the object's attributes. Sections may be nested.

`SPI_ROLE_FORM`

  The object is a container for form controls, for instance as part of a web form or user-input form within a document. This role is primarily a tag/convenience for clients when navigating complex documents, it is not expected that ordinary GUI containers will always have ATK_ROLE_FORM.

`SPI_ROLE_REDUNDANT_OBJECT`

  The object is redundant with another object in the hierarchy, and is exposed for purely technical reasons. Objects of this role should normally be ignored by clients.

`SPI_ROLE_LINK`

  The object is a hypertext anchor.

`SPI_ROLE_INPUT_METHOD_WINDOW`

  The object is an input method window used to input or compose a text character (typically a "complex text" character).

`SPI_ROLE_LAST_DEFINED`

  Used to determine the end of the role enumeration.

### AccessibleRole_getName ()

    char*               AccessibleRole_getName              (AccessibleRole role);

Get a localizeable string that indicates the name of an AccessibleRole. <em>DEPRECATED.</em>

`role` :

  an AccessibleRole object to query.

Returns :

  a localizable string name for an AccessibleRole enumerated type.